/* $Id: labelcheck.c,v 1.1 1996/11/07 08:03:46 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	x`FbN
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include <stdio.h>

#include "analyze.h"
#include "disasm.h"
#include "estruct.h"
#include "etc.h"	/* charout */
#include "global.h"
#include "label.h"	/* regist_label etc. */
#include "offset.h"	/* depend_address , nearadrs */


/* #define DEBUG */


USEOPTION   option_k , option_E , option_I;


static int Label_on_instruction_count = 0;
static int Fixed_count = 0;
static int Undefined_instruction_count = 0;


private void	oops_undefined( address pc0 , address previous_pc , address nlabel )
{
    charout( '+' );
    eprintf( "\n* WARNING! UNDEFINED INSTRUCTION FOUND.\n"
	     "%x - %x (%x)\n" , pc0 , nlabel , previous_pc );
    not_program( pc0 , nlabel );
    Undefined_instruction_count++;
}


private address	labelshift( address previous_pc , address pc , address end ,
				lblbuf *nadrs )
{
    address nlabel = nadrs->label;

    while( nlabel < pc ) {
	charout( '!' );
	nadrs->shift = nlabel - previous_pc;
	regist_label( previous_pc , PROLABEL );
#ifdef	DEBUG
	printf( "* FOUND at %x - %x - %x(diff %d) in opecode\n" ,
		previous_pc , nlabel , pc , nlabel - previous_pc );
#endif
     /* nadrs = next( nlabel + 1 ); */
	nadrs = Next( nadrs );
	nlabel = nadrs->label;
    }
    if( nlabel >= end ) /* D (^_^;) */
	return next_datlabel( previous_pc )->label;
    return end;
}


/*

   DATLABEL Ƃēo^ς݂ǂׂ

*/
private boolean datlabel( address adrs )
{
    lblbuf  *ptr;

    ptr = search_label( adrs );
    if( ptr != NULL && isDATLABEL( ptr->mode ) )
	return TRUE;
    return FALSE;
}


/*

  from  end ܂ŋtAZuĖ߂̓rɃANZXĂƂ{

*/
private address search_change_operand( address from , address end )
{
    address store;
    address nlabel , pc , previous_pc , pc0;
    disasm  code;
    boolean was_prog = FALSE;		/* Ö̗悪vOłǂ */
    lblbuf  *nadrs;

    pc = previous_pc = pc0 = from;

#ifdef	DEBUG
    printf( "search_ch_op(%x - %x)\n" , from , end );
#endif

    while( end != (address)-1 && pc < end ) {
	nadrs = next( pc + 1 );
	nlabel = nadrs->label;
	store = pc + Ofst;
	pc0 = pc;
	was_prog = TRUE;

	while( pc < nlabel && pc < end ) {  /* Q̃vOxԂtAZu */
#ifdef	DEBUG
	    printf( "%x,%x\n" , pc , nlabel );
#endif
	    previous_pc = pc;
	    store += dis( store , &code , &pc );
	    if( code.flag == UNDEF ) {		/* `߂Ȃx */
		oops_undefined( pc0 , previous_pc , nlabel );
#ifdef	OSKDIS
		regist_label(previous_pc, DATLABEL | FORCE);  /* `߂f[^ɂ */
#endif	/* OSKDIS */
		pc = nlabel;
	    }
	}
	if( pc != nlabel ) {		/* ߂̓rɃANZXĂȂ */
#ifdef	DEBUG
	    printf( "* label in instruction( %x , %x )\n" , pc , nlabel );
#endif
	    Label_on_instruction_count++;
	    if( option_k ||
	      ( !option_E && code.size == BYTESIZE &&
		code.op1.eaadrs + 1 != nlabel &&
		code.op2.eaadrs + 1 != nlabel &&
		code.op3.eaadrs + 1 != nlabel &&
		code.op4.eaadrs + 1 != nlabel ) )
	    {
		Fixed_count++;
		charout( '*' );
		not_program( pc0 , nlabel );
		if( option_I ) {
		    eprintf ("\n߂̒x(%x) -> "
			     "f[^̈ɕύX܂(%x-%x)\n",
			nlabel, pc0, nlabel);
		}
		pc = nlabel;
		was_prog = FALSE;
	    } else {
		end = labelshift( previous_pc , pc , end , nadrs );
		if( option_I ) {
		    eprintf ("\n߂̒x(%x -> %x+%x)\n",
			nlabel, previous_pc, nlabel - previous_pc);
		}
	    }
	}
    }
    if( ( code.flag != RTSOP && code.flag != JMPOP ) && datlabel( pc ) && was_prog ) {
	charout( '-' );
#ifdef	DEBUG
	printf( "datlabel in prolabel %x\n" , pc );
#endif
	regist_label( pc , PROLABEL );
    }
    return end;
}


/*

  from  end ܂ł̃f[^̈`FbN

*/
private void	search_change_data( address from , address end )
{
    address store;
    address nlabel , pc , pc0;
    address dependadrs;
    lblbuf  *nadrs;

    pc = pc0 = from;
    nadrs = next( pc );
#ifdef	DEBUG
    printf( "search_ch_dat(%x - %x)\n" , from , end );
#endif
    while( end != (address)-1 && pc < end ) {
     /* nadrs = next( pc + 1 ); */
	nadrs = Next( nadrs );
	nlabel = nadrs->label;
	store = pc + Ofst;

	dependadrs = nearadrs( pc );
	while( dependadrs != (address)-1 && dependadrs + 4 <= nlabel )
	    dependadrs = nearadrs( dependadrs + 1 );

	while( dependadrs < nlabel && nlabel < dependadrs + 4 ) {
	    charout( '!' );
	    nadrs->shift = nlabel - dependadrs;
	    regist_label( dependadrs , DATLABEL | UNKNOWN );
#ifdef	DEBUG
	    printf( "* FOUND at %x (diff %d) in data\n" , dependadrs , nlabel - dependadrs );
#endif
	 /* nadrs = next( nlabel + 1 ); */
	    nadrs = Next( nadrs );
	    nlabel = nadrs->label;
	}
	pc = nlabel;
    }
}


extern void	search_operand_label( void )
{
    lblbuf  *nadrs;
    address pc , pcend;
#if 0
    address tmp;
#endif

    nadrs = next( BeginTEXT );
    pcend = nadrs->label;

    PCEND = Available_text_end;

    while( nadrs->label < Available_text_end ) {
	charout( '.' );
	nadrs = next_prolabel( pcend );

	pc    = nadrs->label;
	nadrs = next_datlabel( pc );
	pcend = nadrs->label;

#if 0
	if( tmp == pcend ) {
	    nadrs = next_prolabel( pcend+1 );
	    pc    = nadrs->label;
	    nadrs = next_datlabel( pc );
	    pcend = nadrs->label;
	    printf("hi܂.\n");
	}
	tmp = pcend;
#endif

#ifdef	OSKDIS
	if (nadrs->label >= Available_text_end) break;  /* D */
#endif	/* OSKDIS */

	if( pcend != (address)-1 )
	    pcend = search_change_operand( pc , pcend );
    }

    charout( '\n' );
    if( Label_on_instruction_count ) {
	if( option_q )
	    eputc( '\n' );
	eprintf( "߂̒wx %d .\n" , Label_on_instruction_count );
	if( Fixed_count )
	    eprintf( "%d ̗̈f[^̈ɕύX܂.\n" , Fixed_count );
    }

    nadrs = next( BeginTEXT );
    pcend = nadrs->label;
    while( nadrs->label < BeginBSS ) {
	charout( ':' );
	nadrs = next_datlabel( pcend /*, nadrs*/ );
	pc = nadrs->label;
	nadrs = next_prolabel( pc /*, nadrs*/ );
	pcend = min( nadrs->label , BeginBSS );

#if 0
	if( tmp == pcend ){
	    nadrs = next_datlabel( pcend );
	    pc = nadrs->label;
	    nadrs = next_prolabel( pc+1 );
	    pcend = min( nadrs->label , BeginBSS );
	    printf("hi2܂.\n");
	}
	tmp = pcend;
#endif


#ifdef	DEBUG
	printf( "chk %x - %x\n" , pc , pcend );
#endif
	if( pc < BeginBSS )
	    search_change_data( pc , pcend );
    }
    if( Undefined_instruction_count )	/* x`FbNɈ|ƃf[^ ? */
	analyze_data();
    if( !option_q || !Label_on_instruction_count )
	eputc( '\n' );
}


/* EOF */
